import PIL.Image as im # module a telecharger en plus de Python
import numpy as np     # module a telecharger en plus de Python (mais parfois inclus)
from math import *

def recadrage_images():
    # ces images doivent se situer dans le repertoire de travail
    # et etre de type RGB ou RGBA (au moins 3 donnees pour chaque pixel)
    # ces images serviront de faces au flexagone.
    # on determine la taille mini commune et on calcule un
    # format L x h inferieur ou egal et tel que h = L * sqrt(3)/2
    # on extrait alors le centre (taille L x h) de chaque image et on
    # l'enregistre sous le nom 'face##.jpg' avec ## = un numero >= 0
    import os
    current_dir = os.getcwd()
    erreur=False
    extensions=['.jpg','.png','jpeg','.gif','.JPG','JPEG','.PNG','.GIF']
    list_in = os.listdir(current_dir+"/")
    """
    debFace=False
    for name in list_in:
        if name[:12]=='facexzt8hk2v' and name[-4:] in extensions:debFace=True
    if debFace:
        print("le nom des fichiers ne doit pas commencer par 'face'")
        r=input("je vais les ecraser, sauf si vous tapez 'n' ")
        if r=='n' or r=='N':return 0,0,0,True,"renommez vos images"
    """
    nb_fichiers=0
    minLig,minCol=100000,100000
    for name in list_in:
        if name[-4:] in extensions:
            if name[:12]!='facexzt8hk2v' and not(name[:5] in ['recto','verso']):
                nb_fichiers+=1
                img = im.open(name)
                tabPix = np.array(img,dtype=np.int16)
                #img.close()
                nbl,nbc,nbcoul=tabPix.shape
                if nbcoul<3:return 0,0,0,True,'les images utilisees doivent etre en RGB ou RGBA'
                if nbl<minLig:minLig=nbl
                if nbc<minCol:minCol=nbc
    if minCol>round(2*minLig/sqrt(3)):minCol=round(2*minLig/sqrt(3))
    else:minLig=min([minLig,round(minCol/2*sqrt(3))])
    minLig,minCol=int(minLig),int(minCol)#####################################################################################################################################################################
    i=0
    for name in list_in:
        if name[-4:] in extensions:
            if name[:12]!='facexzt8hk2v' and not(name[:5] in ['recto','verso']):
                img = im.open(name)
                tabPix = np.array(img,dtype=np.int16)
                nbl,nbc,nbcoul=tabPix.shape
                tab3=np.zeros([minLig,minCol,3])
                debL,debC=(nbl-minLig)//2,(nbc-minCol)//2
                tab3=np.copy(tabPix[debL:debL+minLig,debC:debC+minCol,0:3])
                tab3=np.uint8(tab3)
                img = im.fromarray(tab3)
                img.save("facexzt8hk2v"+str(i)+".jpg")
                i+=1
    return nb_fichiers,minCol,minLig,erreur,""

def OuvrirImage(nomFichier): # on convertit les tableaux de pixels de l'image en tableaux numpy
    img = im.open(nomFichier)# l'adressage est alors tab[ligne,colonne] et non liste[colonne][ligne]
    tabPix = np.array(img,dtype=np.int16)
    return tabPix
def AfficherImage(tabPix,nomFichier): # on convertit un tableau numy en tableau de pixels
    tabPix = np.uint8(tabPix)
    img = im.fromarray(tabPix)
    img.save(nomFichier)              # on enregistre le fichier image

def rotation(i,j,n,lign,colo,centre0,centre1,centre,face):
    # [lign,colo] sont les coord d'un pt ds un triangle dont la base est en haut ou en bas
    # (xpt,ypt) est le point en position analogue dans le triangle j de l'image face[i]
    # (xOrig,yOrig) sont les coord de l'antecedent de (xpt,ypt) par la rotation de centre[j] et d'angle n*pi/3
    y0,x0=centre[j]# centre du triangle j de l'image face[i]
    xpt=colo+x0-centre1 # image de (colo,lign) par la translation
    ypt=lign+y0-centre0 # de vecteur centre[j]-centre
    xOrig=cos(n*pi/3)*(xpt-x0)-sin(n*pi/3)*(ypt-y0)+x0 # la recherche de l'antecedent devrait changer le sgn du sinus
    yOrig=sin(n*pi/3)*(xpt-x0)+cos(n*pi/3)*(ypt-y0)+y0 # mais il y a retournement de l'axe des y (lignes) dans une image
    if np.shape(face[i])[0]>yOrig and np.shape(face[i])[1]>xOrig:
        return face[i][int(yOrig+0.1),int(xOrig+0.1)] # [ligne,colonne] correspond à (colonne,ligne)=(x,y)
    else:return (0,255,0)
        
def placerSousCoin(lig,col,i,j,n,v,h,centre,face,imageFinale,dessus=True):
    # prend le triangle j de face[i] et le fait tourner autour de son
    # centre de n*pi/3. Puis place ces pixels dans imageFinale,
    # dans un triangle a droite du coin [lig,col] et en dessous (si dessus est False) (au dessus sinon)
    l0,c0,l1,c1,l2,c2,coef,moins=v,int(h/2),0,h,0,0,1,0
    if dessus:l0,c0,l1,c1,l2,c2,coef,moins=0,int(h/2),v,h,v,0,2,v
    for lign in range(v):# ligne = ordonnee dans un carre de v lignes sur h col
        gauche=int(c0+(lign-l0)*(c0-c2)/(l0-l2))
        droite=int(c0+(lign-l0)*(c0-c1)/(l0-l1))
        for colo in range(gauche,droite+1):#abscisses dans ce carre
            pix=rotation(i,j,n,lign,colo,coef*v//3,h//2,centre,face)#centre=[v//3,h//2] ou [2*v//3,h//2]
            imageFinale[lign+lig-moins,colo+col]=pix

            
def creation_patron(coin,devant,derriere,RL,v,h,n,ext,boull,ind1,ind2,maxiL,miniL,maxiC,miniC,noir,centre,face):
    hh=30 # marge haut bas gauche et droite

    # recto !
    patron=np.zeros([maxiL-miniL+2*v+60,maxiC-miniC+h+60,3])#################################################################################################################################################
    patron[:,:]=[255,255,255] # tout blanc
    print('recto : (',n,'triangles )')
    booleen=boull # True pour une base de triangle en bas, False pour haut
    # (1er triangle du 1er patron avec base en bas,
    #  pour les patrons suivants, base inverse du dernier triangle construit)
    indice=ind1
    for i in range(n):
        print(i)
        #                                    n face , n triang , rot
        placerSousCoin(coin[i][0],coin[i][1],devant[i]-1,noir[indice][RL[i]],0,v,h,centre,face,patron,booleen)
        ##########################################################if i==0:placerSousCoin(coin[i][0],coin[i][1],devant[i]-1,3,0,patron,booleen)
        indice=(indice+RL[i])%6
        booleen=1-booleen
    ind1=indice
    AfficherImage(patron,'recto'+ext+'.jpg')
    # les segments sont rouges, noirs, ou rouge et noir.
    # il faut plier les rouges. Les 2 autres types doivent etre decoupes
    # seul le dernier triangle aura un bord rouge qu'il faut couper, mais il suffit de le reperer
    # le 1er triangle est un A et sa base est en bas. il a 2 cotes a decouper, et le 2eme triangle
    # est toujours juste au dessus (a droite ou a gauche)

    # verso :
    print('verso')
    patron=np.zeros([maxiL-miniL+2*v+60,maxiC-miniC+h+60,3])############################################################################################################################################################
    patron[:,:]=[255,255,255] # tout blanc
    coin=[[c[0],maxiC-miniC+h+60-h-c[1]] for c in coin]# sym par rapport a axe vertical
    RL=[-c for c in RL]
    booleen=boull # True pour une base de triangle en bas, False pour haut
    # (1er triangle avec base en bas)
    indice=ind2
    for i in range(n):
        print(i)
        #                                    n face , n triang , rot
        placerSousCoin(coin[i][0],coin[i][1],derriere[i]-1,noir[indice][RL[i]],0,v,h,centre,face,patron,booleen)
        ##############################################################################if i==0:placerSousCoin(coin[i][0],coin[i][1],derriere[i]-1,3,0,patron,booleen)
        indice=(indice+RL[i])%6
        booleen=1-booleen
    ind2=indice
    AfficherImage(patron,'verso'+ext+'.jpg')
    return ind1,ind2

def formatA4(larg,Long):
    if Long+20>(larg+20)*1.4142:
        LL=Long+20
        ll=int(LL/1.4142)
        hh=10
        vv=(ll-larg)//2
    else:
        ll=larg+20
        LL=ll*1.4142
        vv=10
        hh=(LL-Long)//2
    return ll,LL,vv,hh

def patron(rep,v,h,hh):
    if rep=='3':
    ############## creation d'un patron de 18 triangles ##############################################
        coin=[[0,0]]
        for i in range(9):coin+=[[v-coin[-1][0],h/2*(i+1)]]
        coin+=[[2*v-c[0],c[1]] for c in coin][1:-1]
        imag=[(1,0,0),(0,0,1),(0,1,1),(2,1,2)]
        imag+=[(2,2,2),(1,3,-2),(1,4,-2),(0,4,-1)]  # i=numero de la face, j=numero du triangle, n
        imag+=[(0,5,-1),(2,5,0)]                    # on doit faire pivoter le triangle j de la face i
        imag+=[(2,0,0),(1,1,2),(1,2,2),(0,2,3)]
        imag+=[(0,3,3),(2,3,-2),(2,4,-2),(1,5,0)]
        ll,LL,vv,hh=formatA4(v,5.5*h)
        coin=[[vv+c[0],hh+c[1]] for c in coin[:10]]+[[vv+c[0]-v,hh+c[1]] for c in coin[10:]]
        nbTri1=10;nbTri2=8
        return ll,LL,nbTri1,nbTri2,coin,imag

    if rep=='4':
    ############## creation d'un patron de 24 triangles ##############################################
        coin2=[[4*v,h/2],[3*v,h],[4*v,3*h/2],[4*v,3*h/2],[5*v,2*h]] # coord [ligne,colonne] des sommets
        coin2=coin2+[[4*v,5*h/2],[5*v,3*h],[5*v,3*h],[6*v,7*h/2]]
        coin2=coin2+[[5*v,4*h],[6*v,9*h/2],[6*v,9*h/2]]
        coin=[[6*v-c[0],c[1]] for c in coin2][:-1]+[[3*v,0]]+[coin2[-1]]+coin2[:-1]
        imag=[(1,5,3),(0,1,2),(2,1,3),(2,2,3),(1,3,1)]              # i=numero de la face, j=numero du triangle, n
        imag+=[(0,3,-2),(2,3,-1),(2,4,-1),(1,1,-1),(0,5,0),(2,5,1)] # on doit faire pivoter le triangle j de la face i
        imag+=[(2,0,1),(0,0,0)]
        imag+=[(3,4,-1),(3,5,-1),(1,4,1),(0,2,2),(3,0,1),(3,1,1)]   # i,j,n
        imag+=[(1,2,-1),(0,4,-2),(3,2,3),(3,3,3),(1,0,3)]
        ll,LL,vv,hh=formatA4(4*v,5.5*h)
        coin=[[vv+v+c[0],hh+c[1]] for c in coin[:12]]+[[vv+c[0]-3*v,hh+c[1]] for c in coin[12:]]
        nbTri1=12;nbTri2=12
        return ll,LL,nbTri1,nbTri2,coin,imag

    if rep=='5':
    ############## creation d'un patron de 30 triangles ##############################################
        coin=[[2*v,0],[2*v,0],[v,h/2],[v,h/2],[0,h]] # coord [ligne,colonne] des sommets
        coin=coin+[[v,3*h/2],[v,3*h/2],[2*v,2*h],[2*v,2*h]]
        coin=coin+[[3*v,5*h/2],[2*v,3*h],[2*v,3*h],[v,7*h/2],[v,7*h/2]]
        coin=coin+[[0,4*h],[v,9*h/2]]
        imag=[(3,5,1),(3,0,1),(4,0,2),(4,1,2),(1,5,3),(0,1,2)] # i=numero de la face, j=numero du triangle, n
        imag+=[(2,2,2),(1,4,1),(0,2,2),(2,3,-2),(3,3,-1)]      # on doit faire pivoter le triangle j de la face i
        imag+=[(3,4,-1),(4,4,0),(4,5,0),(1,1,-1),(0,5,0)]      # d'un angle n*pi/3 autour de son centre
        coin=coin+[[6*v-c[0],c[1]] for c in coin][1:len(coin)-1]
        imag+=[(2,0,0),(1,0,3),(0,0,0),(2,1,2),(3,1,3)]        # i,j,n
        imag+=[(3,2,3),(4,2,-2),(4,3,-2),(1,3,1),(0,3,-2)]
        imag+=[(2,4,-2),(1,2,-1),(0,4,-2),(2,5,0)]
        ll,LL,vv,hh=formatA4(3*v,5.5*h)
        coin=[[vv+c[0],hh+c[1]] for c in coin[:16]]+[[vv+c[0]-3*v,hh+c[1]] for c in coin[16:]]
        nbTri1=16;nbTri2=14
        return ll,LL,nbTri1,nbTri2,coin,imag
    """
    if rep=='6a' or rep=='6A': # modele a (trop long)
    ############## creation d'un patron de 36 triangles ##############################################
        coin=[[0,h/2]]
        for i in range(16):coin=coin+[[v-coin[-1][0],h/2+coin[-1][1]]]
        coin=coin+[[v,0]]          
        imag=[(1,1,3),(2,5,-2),(0,4,2),(1,2,3),(2,4,2),(0,3,2)]    # i=numero de la face, j=numero du triangle, n
        imag+=[(1,3,-1),(2,3,2),(0,2,0),(1,4,-1),(2,2,0),(0,1,0)] # on doit faire pivoter le triangle j de la face i
        imag+=[(1,5,1),(2,1,0),(0,0,-2),(1,0,1),(2,0,-2),(0,5,-2)]  # d'un angle n*pi/3 autour de son centre
        coin=coin+[[c[0],c[1]+h/2] for c in coin]
        imag+=[(5,4,2),(4,5,2),(4,4,2),(3,4,1),(3,3,1),(5,3,0)] # i,j,n
        imag+=[(5,2,0),(4,3,0),(4,2,0),(3,2,-1),(3,1,-1),(5,1,-2)]
        imag+=[(5,0,-2),(4,1,-2),(4,0,-2),(3,0,3),(3,5,3),(5,5,2)]
        ll,LL,vv,hh=formatA4(v,10*h)
        coin=[[vv+c[0],hh+c[1]] for c in coin]
        nbTri1=18;nbTri2=18
        return ll,LL,nbTri1,nbTri2,coin,imag
    """
    
    if rep=='6a' or rep=='6A': # modele a (plus gros)
    ############## creation d'un patron de 36 triangles ##############################################
        coin=[[0,h/2]]
        for i in range(7):coin=coin+[[v-coin[-1][0],h/2+coin[-1][1]]]
        coin=coin+[[c[0]+2*v,c[1]-h/2] for c in coin]
        coin=coin+[[2*v,4*h],[v,0]]           
        imag=[(1,1,3),(2,5,-2),(0,4,2),(1,2,3),(2,4,2),(0,3,2)]    # i=numero de la face, j=numero du triangle, n
        imag+=[(1,3,-1),(2,3,2),(0,2,0),(1,4,-1),(2,2,0),(0,1,0)] # on doit faire pivoter le triangle j de la face i
        imag+=[(1,5,1),(2,1,0),(0,0,-2),(1,0,1),(2,0,-2),(0,5,-2)]  # d'un angle n*pi/3 autour de son centre
        coin=coin+[[coin[i][0]+2*v,coin[i][1]+h/2] for i in range(8)]
        coin=coin+[[coin[i][0]-2*v,coin[i][1]+h/2] for i in range(8,17)]
        coin=coin+[[coin[17][0]+2*v,coin[17][1]+h/2]]
        imag+=[(5,4,2),(4,5,2),(4,4,2),(3,4,1),(3,3,1),(5,3,0)] # i,j,n
        imag+=[(5,2,0),(4,3,0),(4,2,0),(3,2,-1),(3,1,-1),(5,1,-2)]
        imag+=[(5,0,-2),(4,1,-2),(4,0,-2),(3,0,3),(3,5,3),(5,5,2)]
        ll,LL,vv,hh=formatA4(3*v,5.5*h)
        coin=[[vv+c[0],hh+c[1]] for c in coin]
        nbTri1=18;nbTri2=18
        return ll,LL,nbTri1,nbTri2,coin,imag

    if rep=='6b' or rep=='6B': # modele b
    ############## creation d'un patron de 36 triangles ##############################################
        coin=[[2*v,0],[3*v,h/2],[3*v,h/2],[4*v,h],[3*v,3*h/2],[4*v,2*h]]
        coin=coin+[[3*v,5*h/2],[3*v,5*h/2],[2*v,3*h],[2*v,3*h],[v,5*h/2],[v,5*h/2]]
        coin=coin+[[0,2*h],[v,3*h/2],[0,h],[v,h/2],[v,h/2],[2*v,0]]
        coin=coin+[[v,7*h/2+20],[v,7*h/2+20]]               
        imag=[(0,3,3),(4,5,0),(1,2,0),(0,4,-1),(2,4,0),(1,1,0)]    # i=numero de la face, j=numero du triangle, n
        imag+=[(0,5,1),(4,1,-2),(1,0,0),(0,0,3),(2,0,-2),(1,5,0)] # on doit faire pivoter le triangle j de la face i
        imag+=[(0,1,-1),(4,3,2),(1,4,0),(0,2,1),(2,2,2),(1,3,0)]  # d'un angle n*pi/3 autour de son centre
        imag+=[(1,0,0),(0,0,3)]
        coin=coin+coin[:-2]
        imag+=[(3,3,-1),(3,2,-1),(4,4,0),(5,3,0),(5,2,0),(2,1,-2)] # i,j,n
        imag+=[(3,1,-1),(3,0,-1),(4,2,0),(5,1,0),(5,0,0),(2,5,-2)]
        imag+=[(3,5,-1),(3,4,-1),(4,0,0),(5,5,0),(5,4,0),(2,3,-2)]
        ll,LL,vv,hh=formatA4(4*v,4.5*h+20)
        coin=[[vv+c[0],hh+c[1]] for c in coin]
        nbTri1=20;nbTri2=18
        return ll,LL,nbTri1,nbTri2,coin,imag

    if rep=='6c' or rep=='6C': # modele c
    ############## creation d'un patron de 36 triangles ##############################################
        coin=[[0,h/2],[v,h],[v,h],[2*v,h/2],[v,0],[v,0]]               # coord [ligne,colonne] des sommets
        coin=coin+[[i[0]+v,i[1]+1.5*h] for i in coin]                  # des triangles dans le 1er hexagone
        coin=coin+[[coin[i][0]+2*v,coin[i][1]] for i in range(6)]      # du patron, puis dans les 2 hexa voisins
        coin=coin+[[2*v,-h],[2*v,-h]]                                                   # puis les 3 du bas
        imag=[(0,2,0),(1,4,-1),(2,5,3),(5,0,3),(5,1,3),(3,3,2)]    # i=numero de la face, j=numero du triangle, n
        imag+=[(5,3,3),(3,1,-2),(0,0,2),(1,0,-1),(2,3,-1),(5,2,3)] # on doit faire pivoter le triangle j de la face i
        imag+=[(2,1,1),(5,4,3),(5,5,3),(3,5,0),(0,4,-2),(1,2,-1)]  # d'un angle n*pi/3 autour de son centre
        imag+=[(0,0,2),(3,1,-2)]
        # def des 3 derniers hexagones
        coin=[c for c in coin]+[[c[0]+4*v,c[1]] for c in coin][:-1]
        coin[38]=[coin[18][0]+4*v,coin[18][1]]
        coin=[[c[0],h+c[1]] for c in coin]
        imag+=[(1,1,-1),(0,5,0),(3,0,0),(4,1,0),(4,0,0),(2,2,3)] # i,j,n
        imag+=[(4,4,2),(2,4,3),(1,5,1),(0,1,0),(3,2,0),(4,5,2)]
        imag+=[(3,4,0),(4,3,-2),(4,2,-2),(2,0,3),(1,3,3),(0,3,0)]
        imag+=[(1,5,1)]
        ll,LL,vv,hh=formatA4(4*v,4.5*h)
        coin=[[vv+c[0],hh+c[1]] for c in coin[:20]]+[[vv+c[0]-4*v,hh+c[1]] for c in coin[20:]]
        nbTri1=20;nbTri2=19
        return ll,LL,nbTri1,nbTri2,coin,imag
    
    if rep=='7a' or rep=='7A': # modele 7a
    ############## creation d'un patron de 42 triangles ##############################################
        coin=[[v,5*h/2],[v,5*h/2],[0,2*h],[v,3*h/2],[0,h],[v,h/2]]
        coin+=[[v,h/2],[2*v,h],[2*v,h],[3*v,h/2]]
        coin+=[[3*v-coin[i][0],9*h/2-coin[i][1]] for i in range(9,-1,-1)]
        coin+=[[2*v,0],[v,9*h/2]]
        coin+=[[3*v-coin[i][0],coin[i][1]] for i in range(19,-1,-1)]
        imag=[(4,5,1),(1,3,0),(5,5,-1),(5,4,-1),(3,1,-1)]
        imag+=[(4,0,-1),(6,0,0),(6,1,0),(2,5,-1),(0,0,1)]
        imag+=[(3,3,1),(4,2,1),(6,2,2),(6,3,2),(2,1,1)]
        imag+=[(0,4,-1),(1,2,0),(2,2,-1),(0,3,-1),(3,0,3)]
        imag+=[(1,0,-2),(5,2,3)]
        imag+=[(6,4,-2),(4,4,3),(3,5,3),(5,0,1),(5,1,1),(1,1,-2)]
        imag+=[(4,3,-1),(3,4,1),(0,5,1),(2,0,3)]
        imag+=[(5,3,3),(1,5,2),(4,1,3),(3,2,-1)]
        imag+=[(0,1,3),(2,4,1),(1,4,2),(0,2,3),(2,3,3),(6,5,-2)]
        ll,LL,vv,hh=formatA4(3*v,5.5*h)
        coin=[[vv+c[0],hh+c[1]] for c in coin]
        nbTri1=22;nbTri2=20
        return ll,LL,nbTri1,nbTri2,coin,imag
    
    if rep=='7b' or rep=='7B': # modele 7b
    ############## creation d'un patron de 42 triangles ##############################################
        coin=[[v,0]]
        for i in range(6):coin+=[[3*v-coin[i][0],coin[i][1]+h/2]]
        coin+=[coin[-1]]
        for i in range(7,13):coin+=[[v-coin[i][0],coin[i][1]+h/2]]
        coin+=[coin[-1]]
        for i in range(14,20):coin+=[[3*v-coin[i][0],coin[i][1]+h/2]]
        coin+=[[v,0]]
        imag=[(4,4,-2),(5,4,1),(5,3,1),(1,2,3),(2,3,1),(0,2,1)]
        imag+=[(1,3,-1),(3,2,1),(0,1,1),(4,1,2),(3,1,-1),(6,5,0),(6,0,0)]
        imag+=[(2,0,3),(4,2,2),(5,0,3),(5,5,3),(1,0,1),(2,5,3),(0,4,3)]
        imag+=[(1,1,3),(2,4,1)]
        coin+=[[2*v-coin[i][0],coin[i][1]] for i in range(19,-1,-1)]
        imag+=[(6,2,2),(6,1,2),(3,5,3),(4,3,-2),(0,5,-1),(3,0,-1),(1,5,1)]
        imag+=[(0,0,-1),(2,1,-1),(1,4,-1),(5,1,-1),(5,2,-1),(4,0,0),(2,2,-1)]
        imag+=[(6,4,-2),(6,3,-2),(3,3,1),(4,5,0),(0,3,3),(3,4,3)]
        ll,LL,vv,hh=formatA4(2*v,10*h)
        coin=[[vv+c[0],hh+c[1]] for c in coin]
        nbTri1=22;nbTri2=20
        return ll,LL,nbTri1,nbTri2,coin,imag









